<?php
 
namespace Drupal\likebtn\Plugin\Field\FieldFormatter;
 
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;
 
/**
 * @FieldFormatter(
 *   id = "likebtn_formatter",
 *   label = @Translation("Like Button Formatter"),
 *   field_types = {
 *     "likebtn_field",
 *   }
 * )
 */
 
class LikebtnFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];

    foreach ($items as $delta => $item) {
      // The text value has no text format assigned to it, so the user input
      // should equal the output, including newlines.
      $elements[$delta] = [
        '#type' => 'inline_template',
        '#template' => '<i>1234</i>',
        '#context' => ['settings' => '123'],
      ];
    }
    if (empty($elements)) {
      $elements[0] = [
        '#type' => 'inline_template',
        '#template' => '<i>1234</i>',
        '#context' => ['settings' => '123'],
      ];
    }
    return $elements;
  }

  /**
   * {@inheritdoc}
   */
  /*public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = array();

    foreach ($items as $delta => $item) {
      $elements[$delta] = [
        '#type' => 'link',
        '#title' => '123',
        '#url' => 'https://test.com',
      ];
    }
    // foreach ($items as $delta => $item) {
    //   $elements[$delta] = array(
    //     //'uid' => array(
    //       '#markup' =>'123',
    //     //),
    //     // Add more content
    //   );
    // }
 
    return $elements;
  }*/
}